# -*- coding: utf-8 -*-
"""Arch Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template, tmpl_context
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.simpledbobject import *

arch_form = ArchForm(submit_text='Create Arch')

class ArchController(SimpleDbObjectController):
    page_title="Arch"
    myClass = Arch
    url_prefix="arch"
    form = arch_form
    
    @expose(template="mirrormanager.templates.boringform")
    @validate(form=arch_form)
    def create(self, **kwargs):
        if tmpl_context.form_errors:
            flash("Invalid input")
            return self.new(**kwargs)
        SimpleDbObjectController.create(self, **kwargs)
