# -*- coding: utf-8 -*-
"""Host list item Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template, tmpl_context
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *

class HostListitemController(BaseController):
    allow_only = predicates.not_anonymous()
    page_title = ""
    form = None

    def default(self, id):
        return self.do_get(id)
    
    @expose(template="mirrormanager.templates.boringhostform")
    def new(self, **kwargs):
        try:
            hostid=kwargs['hostid']
            host = model.DBSession.query(Host).filter_by(id = hostid).one()
        except Exception, er:
            print "Error:", er
            raise redirect(url("/"))

        host.siteobj = model.DBSession.query(Site).filter_by(id = host.site).one()
        siteadmin_check(host.siteobj, request.identity['repoze.who.userid'])
        submit_action = url("%s/create?hostid=%s" % (self.submit_action_prefix, hostid))
        return dict(form=self.form, values=None, action=submit_action,
            page_title=self.page_title, host=host)
    
    @expose(template="mirrormanager.templates.boringhostform")
    @validate(form=form)
    def create(self, **kwargs):
        if tmpl_context.form_errors:
            flash("Invalid input")
            return self.new(**kwargs)

        if not kwargs.has_key('hostid'):
            turbogears.flash("Error: form did not provide siteid")
            raise redirect("/")
        hostid = kwargs['hostid']

        try:
            host = model.DBSession.query(Host).filter_by(id = hostid).one()
        except Exception, er:
            print "Error:", er
            flash("Error: Host %s does not exist" % hostid)
            raise redirect(url("/"))

        host.siteobj = model.DBSession.query(Site).filter_by(id = host.site).one()
        downstream_siteadmin_check(host.siteobj, request.identity['repoze.who.userid'])

        try:
            self.do_create(host, kwargs)
        except InvalidData, msg:
            flash(msg)
            raise redirect(url("/host/%s" % host.id))
        except Exception, er: # probably sqlite IntegrityError but we can't catch that for some reason... 
            print "Error:", er
            flash("Unexpected Error:", er)

        raise redirect(url("/host/%s" % host.id))

    @expose(template="mirrormanager.templates.boringhostform")
    def delete(self, thing, **kwargs):
        host = thing.host
        siteadmin_check(host.my_site(), identity)
        thing.destroySelf()
        raise redirect(url("/host/%s" % host.id))
