# -*- coding: utf-8 -*-
"""Product Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template, tmpl_context
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.simpledbobject import *

product_form = ProductForm(submit_text='Create Product')


class ProductController(SimpleDbObjectController):
    page_title = "Product"
    form = product_form
    myClass = Product
    url_prefix="product"

    @expose(template="mirrormanager.templates.boringform")
    @validate(form=product_form)
    def create(self, came_from='/', **kwargs):
        if tmpl_context.form_errors:
            flash("Invalid input")
            return self.new(**kwargs)

        SimpleDbObjectController.create(self, **kwargs)
