# -*- coding: utf-8 -*-
"""Repository Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template, tmpl_context
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.simpledbobject import *

repository_form = RepositoryForm(submit_text='Edit Version')


class RepositoryController(SimpleDbObjectController):
    page_title = "Repository"
    form = repository_form
    myClass = Repository
    url_prefix="repository"

    @expose(template="mirrormanager.templates.boringform")
    @validate(form=repository_form)
    def create(self, **kwargs):
        if tmpl_context.form_errors:
            flash("Invalid input")
            return self.new(**kwargs)

        return SimpleDbObjectController.create(self, **kwargs)
    

    @expose(template="mirrormanager.templates.boringform")
    @validate(form=repository_form)
    def update(self, obj, **kwargs):
        if tmpl_context.form_errors:
            flash("Invalid input")
            return self.new(**kwargs)

        model.DBSession.query(Repository).update(kwargs)
        submit_action = url("/repository/%s" % obj)
        redirect(submit_action)
