# -*- coding: utf-8 -*-
"""Site Admin Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template, tmpl_context
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *

siteadmin_form = SiteAdminForm(submit_text='Add Downstream Site')


class SiteAdminController(BaseController):
    allow_only = predicates.not_anonymous()

    def default(self, id):
        v = model.DBSession.query(SiteAdmin).filter_by(id = id).one()
        return dict(values=v, site=v.site, page_title="Site Admin")
    
    @expose(template="mirrormanager.templates.boringsiteform")
    def new(self, siteid):
        try:
            site = model.DBSession.query(Site).filter_by(id = siteid).one()
        except Exception, er:
            print "Error:", er
            raise redirect(url("/"))

        siteadmin_check(site, request.identity['repoze.who.userid'])
        submit_action = url("/siteadmin/create?siteid=%s" % siteid)
        return dict(form=siteadmin_form, values=None,
                    action=submit_action,
                    page_title="New Site Admin", site=site)
    
    @expose(template="mirrormanager.templates.boringsiteform")
    @validate(form=siteadmin_form)
    def create(self, username, siteid):
        if tmpl_context.form_errors:
            print tmpl_context.form_errors
            flash("Invalid input")
            #return self.new(siteid)

        if siteid is None:
            flash("Error: form didn't provide siteid")
            raise redirect("/")

        try:
            site = model.DBSession.query(Site).filter_by(id = siteid).one()
        except Exception, er:
            print "Error:", er
            flash("Error: Site %s does not exist" % siteid)
            raise redirect("/")

        siteadmin_check(site, request.identity['repoze.who.userid'])
        try:
            siteadmin = SiteAdmin(site = site.id, username = username)
            model.DBSession.add(siteadmin)
        except Exception, er: # probably sqlite IntegrityError but we can't catch that for some reason... 
            print "Error:", er
            flash("Error: SiteAdmin %s already exists" % username)
        flash("SiteAdmin created.")
        raise redirect("/site/%s" % siteid)

    @expose(template="mirrormanager.templates.boringsiteform")
    def delete(self, siteadmin, **kwargs):
        sa = model.DBSession.query(SiteAdmin).filter_by(id = siteadmin).one()
        site = model.DBSession.query(Site).filter_by(id = sa.site).one()
        siteadmin_check(site, request.identity['repoze.who.userid'])
        model.DBSession.delete(sa)
        raise redirect("/site/%s" % site.id)
