# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class Category(DeclarativeBase):
    __tablename__ = 'category'

    id = Column(Integer, primary_key=True)
    name = Column(Text)
    product = Column('product_id', Integer, ForeignKey("product.id"))
    canonicalhost = Column(Text,
        default='http://download.fedora.redhat.com')
    topdir = Column('topdir_id', Integer, ForeignKey("directory.id"),
        default=None)
    publiclist = Column(Boolean, default=True)
    #directories = 
    #directories = RelatedJoin('Directory', orderBy='name') # all the directories that are part of this category
    #hostCategories = MultipleJoin('HostCategory')

    def destroySelf(self):
        for hc in self.hostCategories:
            hc.destroySelf()
        SQLObject.destroySelf(self)

    def directories_newer_than(self, since):
        result = []
        for d in self.directories:
            if d.ctime > since:
                result.append(d.name)
        return result
