# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class FileDetail(DeclarativeBase):
    __tablename__ = 'file_detail'
    
    id = Column(Integer, primary_key=True)
    directory = Column('directory_id', Integer, \
        ForeignKey("directory.id"), nullable=False)
    filename = Column(Text, nullable=False)
    timestamp = Column(BigInteger, default=None)
    size = Column(BigInteger, default=None)
    sha1 = Column(Text, default=None)
    md5 = Column(Text, default=None)
    sha256 = Column(Text, default=None)
    sha512 = Column(Text, default=None)
