# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class HostCategoryDir(DeclarativeBase):
    __tablename__ = 'host_category_dir'

    
    id = Column(Integer, primary_key=True)
    host_category = Column('host_category_id', Integer,
        ForeignKey('host_category.id'))
    # subset of the path starting below HostCategory.path
    path = Column(Text)
    directory = Column('directory_id', Integer, ForeignKey('directory.id'))
    hcdindex = UniqueConstraint('path', 'host_category', name='hcdindex')
    up2date = Column(Boolean, default=True)
    files = Column(PickleType, default=None)
    lastCrawled = Column(DateTime, default=None)
