# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode, PickleType
#from sqlalchemy.orm import relation, backref
from datetime import datetime

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class HostStats(DeclarativeBase):
    __tablename__ = 'host_stats'

    id = Column(Integer, primary_key=True)
    host = Column('host_id', Integer, ForeignKey('host.id'))
    _timestamp = Column(DateTime, default=datetime.utcnow())
    type = Column(Text, default=None)
    data = Column(PickleType, default=None)
