# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class Repository(DeclarativeBase):
    __tablename__ = 'repository'

    id = Column(Integer, primary_key=True)
    name = Column(Text)
    prefix = Column(Text, default=None)
    category = Column('category_id', Integer, ForeignKey("category.id"))
    version = Column('version_id', Integer, ForeignKey("version.id"))
    arch = Column('arch_id', Integer, ForeignKey("arch.id"))
    directory = Column('directory_id', Integer, ForeignKey("directory.id"))
    disabled = Column(Boolean, default=False)
    idx = UniqueConstraint('prefix', 'arch', name='idx')
