# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class SiteToSite(DeclarativeBase):
    __tablename__ = 'site_to_site'

    id = Column(Integer, primary_key=True)
    upstream_site = Column('upstream_site_id', Integer,
        ForeignKey("site.id"))
    downstream_site = Column('downstream_site_id', Integer,
        ForeignKey("site.id"))
    idx = UniqueConstraint('upstream_site', 'downstream_site', name='idx')

    def my_site(self):
        return self.upstream_site
