# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class Version(DeclarativeBase):
    __tablename__ = 'version'

    id = Column(Integer, primary_key=True)
    name = Column(Text)
    product = Column('product_id', Integer, ForeignKey("product.id"))
    isTest = Column(Boolean, default=False)
    display = Column(Boolean, default=True)
    display_name = Column(Text, default=None)
    ordered_mirrorlist = Column(Boolean, default=True)
